
Redmine - Feature #30998

Add an rake task to prune registered users after a certain number of days

2019-03-08 15:45 - David Demelier

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Accounts / authentication Estimated time: 0.00 hour

Target version: 5.0.0   

Resolution: Fixed   

Description

Hello,

Unfortunately I'm not enough skilled in ruby to propose a patch.

Like many other people, I'm affected by spammers that half-register themselves but do not complete inscriptions due their fake

emails. So I constantly have a pile of half-registered users that pollute my database.

It could be nice if there was an option to automatically delete accounts that were not successfully registered after a given amount of

time (example, 1 day by default or something like that).

What do you think?

Related issues:

Related to Redmine - Patch #41023: Set default age parameter for User.prune t... Closed

Has duplicate Redmine - Feature #38541: Automatic deletion of unactivated acc... Closed

Associated revisions

Revision 21490 - 2022-03-22 05:02 - Go MAEDA

Add tasks to prune registered users after a certain number of days (#30998).

Patch by Yuichi HARADA and Marius BALTEANU.

History

#1 - 2019-03-28 13:36 - David Demelier

For those who are interested, I usually process this easily by:

delete from users where status = 2;

 Not sure if it's really safe while redmine is running though.

#2 - 2021-04-14 07:22 - Go MAEDA

How about adding a rake task redmine:users:prune to remove users who have not completed their registration?

Redmine already has a similarly named rake task redmine:attachments:prune (source:tags/4.2.0/lib/tasks/redmine.rake#L20). The rake task deletes

files that have been uploaded but not attached to an issue or wiki page.

#3 - 2021-04-19 02:32 - Yuichi HARADA

- File 30998.patch added

Go MAEDA wrote:

How about adding a rake task redmine:users:prune to remove users who have not completed their registration?

 +1

I created a rake task redmine:users:prune.

diff --git a/app/models/user.rb b/app/models/user.rb

index a3d2449d2..af65d5aaa 100644
--- a/app/models/user.rb

+++ b/app/models/user.rb

@@ -887,6 +887,10 @@ class User < Principal

     project_ids.map(&:to_i)

   end

+  def self.prune(age=1.day)

+    User.where("created_on < ? AND status = ?", Time.now - age, STATUS_REGISTERED).destroy_all

+  end

+

   protected

   def validate_password_length

diff --git a/lib/tasks/redmine.rake b/lib/tasks/redmine.rake

index 2bebaf18c..8cdf6f80f 100644

--- a/lib/tasks/redmine.rake

+++ b/lib/tasks/redmine.rake

@@ -40,6 +40,13 @@ namespace :redmine do

     end

   end

+  namespace :users do

+    desc 'Remove users who could not be activated after one day.'

+    task :prune => :environment do

+      User.prune

+    end

+  end

+

   namespace :watchers do

     desc 'Removes watchers from what they can no longer view.'

     task :prune => :environment do

#4 - 2021-04-23 12:05 - Go MAEDA

- Target version set to Candidate for next major release

#5 - 2021-06-30 17:15 - Go MAEDA

- File 30998-v2.patch added

Thank you for the patch.

I have changed the patch to remove users registered more than 7 days ago. I think one day is too short.

Suppose that you set "Self-registration" to "manual account activation" and run the rake task every day. When the admin receives a notification that a

user has registered, the admin must activate the user within one day or the user will be deleted. All users who register after Friday afternoon may be

deleted by Monday morning.

#6 - 2021-12-18 08:42 - Go MAEDA

- File 30998-v3.patch added

- Target version changed from Candidate for next major release to 5.0.0

Updated the patch for the trunk r21318. Setting the target version to 5.0.0.

#7 - 2022-01-05 05:24 - Marius BĂLTEANU

The rake task should accept the number of days as parameter in order to make this configurable. Also, the default value should be at least 7 days or

even 30 days. One day is too less.

#8 - 2022-03-18 22:57 - Marius BĂLTEANU

- File 0001-Add-tasks-to-prune-registered-users-after-a-certain-.patch added

Go Maeda, what do you think about the following implementation?

#9 - 2022-03-19 08:57 - Marius BĂLTEANU

- Assignee set to Go MAEDA

#10 - 2022-03-19 10:31 - Go MAEDA

Marius BALTEANU wrote:
Go Maeda, what do you think about the following implementation?

 Looks nice, thank you!

#11 - 2022-03-22 05:03 - Go MAEDA

- Subject changed from Delete account not fully registered after an amount of time to Add an rake task to prune registered users after a certain

number of days

- Status changed from New to Closed

- Resolution set to Fixed

Committed the patch. Thank you.

#12 - 2023-05-13 09:40 - Go MAEDA

- Has duplicate Feature #38541: Automatic deletion of unactivated accounts added

#13 - 2024-07-16 05:55 - Go MAEDA

- Related to Patch #41023: Set default age parameter for User.prune to 30 days added

Files

30998.patch 1.63 KB 2021-04-19 Yuichi HARADA

30998-v2.patch 1.67 KB 2021-06-30 Go MAEDA

30998-v3.patch 1.53 KB 2021-12-18 Go MAEDA

0001-Add-tasks-to-prune-registered-users-after-a-certain-.patch 2.26 KB 2022-03-18 Marius BĂLTEANU
